<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

declare(strict_types=1);

use Migrations\AbstractMigration;

/**
 * Class Initial
 *
 * Created:
 * oitc migrations create -p PrometheusModule Initial
 *
 * Usage:
 * openitcockpit-update
 */
class Initial extends AbstractMigration {

    /**
     * Whether the tables created in this migration
     * should auto-create an `id` field or not
     *
     * This option is global for all tables created in the migration file.
     * If you set it to false, you have to manually add the primary keys for your
     * tables using the Migrations\Table::addPrimaryKey() method
     *
     * @var bool
     */
    public $autoId = false;

    /**
     * Change Method.
     *
     * More information on this method is available here:
     * https://book.cakephp.org/phinx/0/en/migrations.html#the-change-method
     * @return void
     */
    public function change(): void {
        $table = $this->table('prometheus_exporters');
        $table
            ->addColumn('id', 'integer', [
                'autoIncrement' => true,
                'default'       => null,
                'limit'         => 10,
                'null'          => false,
            ])
            ->addPrimaryKey(['id']);
        $table
            ->addColumn('name', 'string', [
                'default' => null,
                'limit'   => 255,
                'null'    => false,
            ])
            ->addColumn('container_id', 'integer', [
                'null' => false,
            ])
            ->addColumn('metric_path', 'string', [
                'default' => '/metrics',
                'limit'   => 128,
                'null'    => false,
            ])
            ->addColumn('port', 'integer', [
                'null' => false,
            ])
            ->addColumn('scrape_interval', 'string', [
                'default' => null,
                'limit'   => 128,
                'null'    => false,
            ])
            ->addColumn('service', 'string', [
                'default' => null,
                'limit'   => 255,
                'null'    => false,
            ])
            ->addColumn('yaml', 'text', [
                'default' => null,
                'limit'   => null,
                'null'    => false,
            ])
            ->create();
    }
}
