<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace PrometheusModule\Lib;


use App\Lib\PluginAclDependencies;

class AclDependencies extends PluginAclDependencies {

    public function __construct() {
        parent::__construct();

        // Add actions that should always be allowed.
        $this
            ->allow('PrometheusQuery', 'getPerfdataByUuid');

        ///////////////////////////////
        //    Add dependencies       //
        //////////////////////////////

        $this
            ->dependency('PrometheusQuery', 'index', 'PrometheusQuery', 'loadHostsByString');

        $this
            ->dependency('PrometheusQuery', 'toService', 'PrometheusQuery', 'loadCurrentValueByMetric')
            ->dependency('PrometheusQuery', 'toService', 'PrometheusQuery', 'loadValueByMetric')
            ->dependency('PrometheusQuery', 'toService', 'PrometheusQuery', 'validateService')
            ->dependency('PrometheusQuery', 'toService', 'PrometheusQuery', 'loadServicetemplates')
            ->dependency('PrometheusQuery', 'toService', 'PrometheusQuery', 'createService')
            ->dependency('Services', 'browser', 'PrometheusQuery', 'browser_directive');

        $this
            ->dependency('PrometheusExporters', 'add', 'PrometheusExporters', 'loadContainers');

        $this
            ->dependency('ConfigurationFiles', 'edit', 'ConfigurationFiles', 'PrometheusCfgsPrometheus')
            ->dependency('ConfigurationFiles', 'edit', 'ConfigurationFiles', 'restorDefault');
    }

}
