<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace PrometheusModule\Lib;


use itnovum\openITCOCKPIT\Core\Wizards\ModuleWizardsInterface;

class Wizards implements ModuleWizardsInterface {

    /**
     * @var array
     */
    private $ACL_PERMISSIONS = [];

    /**
     * Widgets constructor.
     * @param $ACL_PERMISSIONS
     */
    public function __construct($ACL_PERMISSIONS) {
        $this->ACL_PERMISSIONS = $ACL_PERMISSIONS;
    }

    /**
     * @return array
     */
    public function getAvailableWizards() {
        if (!(isset($this->ACL_PERMISSIONS['hosts']['add']) && isset($this->ACL_PERMISSIONS['services']['add']))) {
            return [];
        }
        $wizards = [];
        //if (isset($this->ACL_PERMISSIONS['prometheusmodule']['scans']['index'])) {
        $wizards = [
            'prometheus' => [
                'type_id'                 => 'prometheus',
                'uuid'                    => 'a87e8fbf-c681-4a17-a257-db29c4c3bd5f',
                'title'                   => __('Prometheus'),
                'description'             => __('Metrics based monitoring using Prometheus'),
                'image'                   => 'prometheus.svg',
                'directive'               => 'linux-server-checkmk', //AngularJS directive
                'state'                   => 'PrometheusQueryIndex',
                'category'                => ['prometheus', 'linux', 'windows'],
                'selected_os'             => null,
                'necessity_of_assignment' => false
            ]
        ];
        //}

        return $wizards;
    }

}
