<?php
declare(strict_types=1);

namespace PrometheusModule\Model\Entity;

use Cake\ORM\Entity;

/**
 * PrometheusAlertRule Entity
 *
 * @property int $id
 * @property int $host_id
 * @property int $service_id
 * @property string $promql
 * @property string $unit
 * @property string $threshold_type
 * @property float $warning_min
 * @property float $warning_max
 * @property float $critical_min
 * @property float $critical_max
 * @property string $warning_longer_as
 * @property string $critical_longer_as
 * @property string $warning_operator
 * @property string $critical_operator
 * @property \Cake\I18n\FrozenTime $created
 * @property \Cake\I18n\FrozenTime $modified
 *
 * @property \App\Model\Entity\Host $host
 * @property \App\Model\Entity\Service $service
 */
class PrometheusAlertRule extends Entity {
    /**
     * Fields that can be mass assigned using newEntity() or patchEntity().
     *
     * Note that when '*' is set to true, this allows all unspecified fields to
     * be mass assigned. For security purposes, it is advised to set '*' to false
     * (or remove it), and explicitly make individual fields accessible as needed.
     *
     * @var array
     */
    protected $_accessible = [
        'host_id'            => true,
        'service_id'         => true,
        'promql'             => true,
        'unit'               => true,
        'threshold_type'     => true,
        'warning_min'        => true,
        'warning_max'        => true,
        'critical_min'       => true,
        'critical_max'       => true,
        'warning_longer_as'  => true,
        'critical_longer_as' => true,
        'warning_operator'   => true,
        'critical_operator'  => true,
        'created'            => true,
        'modified'           => true,
        'host'               => true,
        'service'            => true
    ];
}
