<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <a ui-sref="PrometheusQueryIndex">
            <i class="fas fa-burn"></i> <?php echo __('Prometheus Module'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fas fa-bullhorn"></i> <?php echo __('Alert rules'); ?>
    </li>
</ol>

<div class="row">
    <div class="col-lg-8 margin-bottom-10">
        <div class="input-group">
            <select
                    id="ServiceListHostSelect"
                    data-placeholder="<?php echo __('Please select...'); ?>"
                    class="form-control"
                    chosen="hosts"
                    callback="loadHosts"
                    ng-options="host.key as host.value for host in hosts"
                    ng-model="hostId">
            </select>
        </div>
    </div>
</div>

<massdelete></massdelete>

<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Prometheus alert rules'); ?>
                    <span class="fw-300"><i><?php echo __('of Host'); ?></i></span>
                </h2>
                <div class="panel-toolbar">

                    <ul class="nav nav-tabs border-bottom-0 nav-tabs-clean" role="tablist">
                        <?php if ($this->Acl->hasPermission('index', 'PrometheusQuery', 'PrometheusModule')): ?>
                            <li class="nav-item">
                                <a class="nav-link" data-toggle="tab"
                                   ui-sref="PrometheusQueryIndex({hostId: hostId})" role="tab">
                                    <i class="fas fa-chart-line">&nbsp;</i> <?php echo __('Metrics'); ?>
                                </a>
                            </li>
                        <?php endif; ?>
                        <?php if ($this->Acl->hasPermission('index', 'PrometheusAlertRules', 'PrometheusModule')): ?>
                            <li class="nav-item">
                                <a class="nav-link active" data-toggle="tab"
                                   ui-sref="PrometheusAlertRulesIndex({hostId: hostId})" role="tab">
                                    <i class="fas fa-bullhorn">&nbsp;</i> <?php echo __('Alert rules'); ?>
                                </a>
                            </li>
                        <?php endif; ?>
                    </ul>

                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                        <i class="fas fa-sync"></i> <?php echo __('Refresh'); ?>
                    </button>

                    <button class="btn btn-xs btn-primary shadow-0" ng-click="triggerFilter()">
                        <i class="fas fa-filter"></i> <?php echo __('Filter'); ?>
                    </button>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">

                    <!-- Start Filter -->
                    <div class="list-filter card margin-bottom-10" ng-show="showFilter">
                        <div class="card-header">
                            <i class="fa fa-filter"></i> <?php echo __('Filter'); ?>
                        </div>
                        <div class="card-body">
                            <div class="row">
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fa fa-cogs"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by service name'); ?>"
                                                   ng-model="filter.servicename"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>

                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fa fa-filter"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by PromQL'); ?>"
                                                   ng-model="filter.PrometheusAlertRules.promql"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>

                            </div>

                            <div class="float-right">
                                <button type="button" ng-click="resetFilter()"
                                        class="btn btn-xs btn-danger">
                                    <?php echo __('Reset Filter'); ?>
                                </button>
                            </div>
                        </div>
                    </div>
                    <!-- End Filter -->

                    <div class="frame-wrap">
                        <table class="table table-striped m-0 table-bordered table-hover table-sm">
                            <thead>
                            <tr>
                                <th class="no-sort text-center">
                                    <i class="fa fa-check-square"></i>
                                </th>

                                <th class="no-sort text-center">
                                    <i class="fa fa-lg fa-area-chart" title="<?php echo __('Grapher'); ?>"></i>
                                </th>

                                <th class="no-sort" ng-click="orderBy('servicename')">
                                    <i class="fa" ng-class="getSortClass('servicename')"></i>
                                    <?php echo __('Service name'); ?>
                                </th>

                                <th class="no-sort" ng-click="orderBy('PrometheusAlertRules.promql')">
                                    <i class="fa" ng-class="getSortClass('PrometheusAlertRules.promql')"></i>
                                    <?php echo __('PromQL'); ?>
                                </th>

                                <th class="no-sort">
                                    <?php echo __('Unit'); ?>
                                </th>

                                <th class="no-sort text-center editItemWidth">
                                    <i class="fa fa-gear fa-lg"></i>
                                </th>
                            </tr>
                            </thead>

                            <tbody>
                            <tr ng-repeat="alert_rule in alert_rules">

                                <td class="width-5">
                                    <input type="checkbox"
                                           ng-model="massChange[alert_rule._matchingData.PrometheusAlertRules.service_id]"
                                           ng-show="alert_rule.allow_edit">
                                </td>

                                <td class="text-center">
                                    <div ng-mouseenter="mouseenter($event, alert_rule._matchingData.Hosts.uuid, alert_rule._matchingData.PrometheusAlertRules.promql, 1)"
                                         ng-mouseleave="mouseleave()">
                                        <i class="fa fa-lg fa-area-chart">
                                        </i>
                                    </div>
                                </td>

                                <td>
                                    <?php if ($this->Acl->hasPermission('browser', 'services')): ?>
                                        <a ui-sref="ServicesBrowser({id:alert_rule._matchingData.PrometheusAlertRules.service_id})">
                                            {{ alert_rule.servicename }}
                                        </a>
                                    <?php else: ?>
                                        {{ alert_rule.servicename }}
                                    <?php endif; ?>
                                </td>

                                <td>
                                    <code class="no-background">{{ alert_rule._matchingData.PrometheusAlertRules.promql
                                        }}</code>
                                </td>
                                <td>
                                    {{ alert_rule._matchingData.PrometheusAlertRules.unit }}
                                </td>

                                <td class="width-50">
                                    <div class="btn-group btn-group-xs" role="group">
                                        <?php if ($this->Acl->hasPermission('editService', 'PrometheusQuery', 'PrometheusModule')): ?>
                                            <a ui-sref="PrometheusQueryEditService({serviceId: alert_rule.id})"
                                               ng-if="alert_rule.allow_edit"
                                               class="btn btn-default btn-lower-padding">
                                                <i class="fa fa-cog"></i>
                                            </a>
                                            <a href="javascript:void(0);"
                                               ng-if="!alert_rule.allow_edit"
                                               class="btn btn-default btn-lower-padding disabled">
                                                <i class="fa fa-cog"></i>
                                            </a>
                                        <?php else: ?>
                                            <a href="javascript:void(0);"
                                               class="btn btn-default btn-lower-padding disabled">
                                                <i class="fa fa-cog"></i></a>
                                        <?php endif; ?>
                                        <button type="button"
                                                class="btn btn-default dropdown-toggle btn-lower-padding"
                                                data-toggle="dropdown">
                                            <i class="caret"></i>
                                        </button>
                                        <div class="dropdown-menu dropdown-menu-right">
                                            <?php if ($this->Acl->hasPermission('editService', 'PrometheusQuery', 'PrometheusModule')): ?>
                                                <a ui-sref="PrometheusQueryEditService({serviceId: alert_rule.id})"
                                                   ng-if="alert_rule.allow_edit"
                                                   class="dropdown-item">
                                                    <i class="fa fa-cog"></i>
                                                    <?php echo __('Edit alert rule'); ?>
                                                </a>
                                            <?php endif; ?>
                                            <?php
                                            $AdditionalLinks = new \App\Lib\AdditionalLinks($this);
                                            echo $AdditionalLinks->getLinksAsHtmlList('PrometheusAlertRules', 'index', 'list');
                                            ?>
                                            <?php if ($this->Acl->hasPermission('delete', 'services')): ?>
                                                <div class="dropdown-divider"></div>
                                                <a ng-click="confirmDelete(getObjectForDelete(alert_rule))"
                                                   ng-if="alert_rule.allow_edit"
                                                   class="dropdown-item txt-color-red">
                                                    <i class="fa fa-trash"></i>
                                                    <?php echo __('Delete'); ?>
                                                </a>
                                            <?php endif; ?>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                            </tbody>
                        </table>
                        <div class="margin-top-10" ng-show="alert_rules.length == 0">
                            <div class="text-center text-danger italic">
                                <?php echo __('No entries match the selection'); ?>
                            </div>
                        </div>

                        <?php if ($this->Acl->hasPermission('toService', 'PrometheusQuery', 'PrometheusModule')): ?>
                            <div class="row margin-top-10 margin-bottom-10">
                                <div class="col-xs-12 col-md-2 text-muted text-center">
                                    <span ng-show="selectedElements > 0">({{selectedElements}})</span>
                                </div>
                                <div class="col-xs-12 col-md-2">
                                    <span ng-click="selectAll()" class="pointer">
                                        <i class="fas fa-lg fa-check-square"></i>
                                        <?php echo __('Select all'); ?>
                                    </span>
                                </div>
                                <div class="col-xs-12 col-md-2">
                                    <span ng-click="undoSelection()" class="pointer">
                                        <i class="fas fa-lg fa-square"></i>
                                        <?php echo __('Undo selection'); ?>
                                    </span>
                                </div>

                                <?php if ($this->Acl->hasPermission('delete', 'services')): ?>
                                    <div class="col-xs-12 col-md-2 txt-color-red">
                                    <span ng-click="confirmDelete(getObjectsForDelete())" class="pointer">
                                        <i class="fas fa-trash"></i>
                                        <?php echo __('Delete selected'); ?>
                                    </span>
                                    </div>
                                <?php endif; ?>
                            </div>
                        <?php endif; ?>
                        <scroll scroll="scroll" click-action="changepage" ng-if="scroll"></scroll>
                        <paginator paging="paging" click-action="changepage" ng-if="paging"></paginator>
                        <?php echo $this->element('paginator_or_scroll'); ?>

                        <popover-prometheus-graph-directive></popover-prometheus-graph-directive>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
