<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

$ScrapeIntervals = new \PrometheusModule\Lib\ScrapeIntervals();
?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <a ui-sref="PrometheusQueryIndex">
            <i class="fas fa-burn"></i> <?php echo __('Prometheus Module'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <a ui-sref="PrometheusExportersIndex">
            <i class="fas fa-broadcast-tower"></i> <?php echo __('Exporters Overview'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fa fa-plus"></i> <?php echo __('Add'); ?>
    </li>
</ol>

<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Create new exporter'); ?>
                </h2>
                <div class="panel-toolbar">
                    <a back-button href="javascript:void(0);" fallback-state='PrometheusExportersIndex'
                       class="btn btn-default btn-xs mr-1 shadow-0">
                        <i class="fas fa-long-arrow-alt-left"></i> <?php echo __('Back'); ?>
                    </a>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">
                    <form ng-submit="submit();" class="form-horizontal"
                          ng-init="successMessage=
                            {objectName : '<?php echo __('Exporter'); ?>' , message: '<?php echo __('created successfully'); ?>'}">

                        <div class="form-group required" ng-class="{'has-error': errors.container_id}">
                            <label class="control-label" for="ExporterContainer">
                                <?php echo __('Container'); ?>
                            </label>
                            <select
                                    data-placeholder="<?php echo __('Please choose'); ?>"
                                    class="form-control"
                                    chosen="containers"
                                    id="ExporterContainer"
                                    ng-options="container.key as container.value for container in containers"
                                    ng-model="post.PrometheusExporter.container_id">
                            </select>
                            <div ng-show="post.PrometheusExporter.container_id < 1" class="warning-glow">
                                <?php echo __('Please select a container.'); ?>
                            </div>
                            <div ng-repeat="error in errors.container_id">
                                <div class="help-block text-danger">{{ error }}</div>
                            </div>
                        </div>

                        <div class="form-group required" ng-class="{'has-error':errors.name}">
                            <label class="control-label">
                                <?php echo __('Name'); ?>
                            </label>
                            <input
                                    ng-model="post.PrometheusExporter.name"
                                    class="form-control"
                                    maxlength="255"
                                    type="text"
                                    id="SatelliteName">
                            <div ng-repeat="error in errors.name">
                                <div class="help-block text-danger">{{ error }}</div>
                            </div>
                        </div>

                        <div class="form-group required" ng-class="{'has-error': errors.scrape_interval}">
                            <label class="control-label" for="ScrapeIntervalSelect">
                                <?php echo __('Scrape interval'); ?>
                            </label>
                            <select
                                    data-placeholder="<?php echo __('Please choose'); ?>"
                                    class="form-control"
                                    chosen="containers"
                                    id="ScrapeIntervalSelect"
                                    ng-model="post.PrometheusExporter.scrape_interval">
                                <?php foreach ($ScrapeIntervals->getScrapeIntervals() as $intervalKey => $intervalName): ?>
                                    <option value="<?= h($intervalKey) ?>"><?= h($intervalName) ?></option>
                                <?php endforeach; ?>
                            </select>
                            <div ng-repeat="error in errors.scrape_interval">
                                <div class="help-block text-danger">{{ error }}</div>
                            </div>
                            <div class="help-block">
                                <?= __('How frequently Prometheus will request data from the exporter.') ?>
                            </div>
                        </div>

                        <div class="form-group required" ng-class="{'has-error': errors.scrape_timeout}">
                            <label class="control-label" for="ScrapeTimeoutSelect">
                                <?php echo __('Scrape timeout'); ?>
                            </label>
                            <select
                                    data-placeholder="<?php echo __('Please choose'); ?>"
                                    class="form-control"
                                    chosen="containers"
                                    id="ScrapeTimeoutSelect"
                                    ng-model="post.PrometheusExporter.scrape_timeout">
                                <?php foreach ($ScrapeIntervals->getScrapeIntervals() as $intervalKey => $intervalName): ?>
                                    <option value="<?= h($intervalKey) ?>"><?= h($intervalName) ?></option>
                                <?php endforeach; ?>
                            </select>
                            <div ng-repeat="error in errors.scrape_timeout">
                                <div class="help-block text-danger">{{ error }}</div>
                            </div>
                            <div class="help-block">
                                <?= __('How long Prometheus will wait for an request to complete before it will timeout.') ?>
                            </div>
                        </div>

                        <div class="form-group required" ng-class="{'has-error':errors.service}">
                            <label class="control-label">
                                <?php echo __('Service'); ?>
                            </label>
                            <input
                                    ng-model="post.PrometheusExporter.service"
                                    class="form-control"
                                    maxlength="255"
                                    type="text"
                                    placeholder="os">
                            <div ng-repeat="error in errors.service">
                                <div class="help-block text-danger">{{ error }}</div>
                            </div>
                            <div class="help-block">
                                <?= __('A one word description like "os", "webserver" or "mysql" to make Prometheus queries easier.') ?>
                            </div>
                        </div>

                        <div class="form-group required" ng-class="{'has-error':errors.metric_path}">
                            <label class="control-label">
                                <?php echo __('Metric path'); ?>
                            </label>
                            <input
                                    ng-model="post.PrometheusExporter.metric_path"
                                    class="form-control"
                                    maxlength="255"
                                    type="text"
                                    placeholder="/metrics">
                            <div ng-repeat="error in errors.metric_path">
                                <div class="help-block text-danger">{{ error }}</div>
                            </div>
                        </div>

                        <div class="form-group required" ng-class="{'has-error':errors.port}">
                            <label class="control-label">
                                <?php echo __('Port'); ?>
                            </label>
                            <input
                                    ng-model="post.PrometheusExporter.port"
                                    class="form-control"
                                    maxlength="255"
                                    type="number"
                                    placeholder="9100">
                            <div ng-repeat="error in errors.port">
                                <div class="help-block text-danger">{{ error }}</div>
                            </div>
                            <div class="help-block">
                                <?= __('The prometheus documentation provides a list of'); ?>
                                <a href="https://github.com/prometheus/prometheus/wiki/Default-port-allocations" target="_blank">
                                    <?= __('default port allocations.') ?>
                                </a>
                            </div>
                        </div>

                        <div class="form-group">
                            <div class="col-12">
                                <div class="custom-control custom-checkbox">
                                    <input type="checkbox"
                                           id="AddTargetPort"
                                           name="checkbox"
                                           class="custom-control-input"
                                           ng-model="post.PrometheusExporter.add_target_port">
                                    <label class="custom-control-label"
                                           for="AddTargetPort"><?php echo __('Add port to targets'); ?></label>
                                </div>
                            </div>
                            <div class="help-block">
                                <?= __('Most exports requires that the port number gets added to the target address (e.g node_exporter).'); ?>
                                <?= __('For the snmp_exporter you have to untick this.'); ?>
                            </div>
                        </div>

                        <div class="form-group" ng-class="{'has-error':errors.yaml}">
                            <label class="control-label">
                                <?php echo __('YAML config'); ?>
                            </label>
                            <textarea
                                    class="form-control"
                                    rows="6"
                                    ng-model="post.PrometheusExporter.yaml"></textarea>
                            <div ng-repeat="error in errors.yaml">
                                <div class="help-block text-danger">{{ error }}</div>
                            </div>
                            <div class="help-block">
                                <?= __('Some exporters like the "Blackbox exporter" or "SNMP exporter" require a special YAML configuration. Deeper Prometheus knowledge is recommended.') ?>
                            </div>
                        </div>


                        <div class="card margin-top-10">
                            <div class="card-body">
                                <div class="float-right">
                                    <label>
                                        <input type="checkbox" ng-model="data.createAnother">
                                        <?php echo __('Create another'); ?>
                                    </label>
                                    <button class="btn btn-primary" type="submit">
                                        <?php echo __('Create exporter'); ?>
                                    </button>
                                    <a back-button href="javascript:void(0);" fallback-state='PrometheusExportersIndex'
                                       class="btn btn-default">
                                        <?php echo __('Cancel'); ?>
                                    </a>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>