<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <a ui-sref="PrometheusQueryIndex">
            <i class="fas fa-burn"></i> <?php echo __('Prometheus Module'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fa fa-code"></i> <?php echo __('Query Overview'); ?>
    </li>
</ol>

<div class="row">
    <div class="col-xs-12 col-md-12 col-lg-8 margin-bottom-10">
        <div class="input-group">
            <select
                    id="ServiceListHostSelect"
                    data-placeholder="<?php echo __('Please select...'); ?>"
                    class="form-control"
                    chosen="hosts"
                    callback="loadHosts"
                    ng-options="host.key as host.value for host in hosts"
                    ng-model="hostId">
            </select>
        </div>
    </div>
</div>

<div class="row">
    <div class="col-lg-12">

        <div class="alert alert-primary border-faded">
            <div class="d-flex align-items-center">
                <div class="alert-icon">
                    <span class="icon-stack icon-stack-md">
                        <i class="base-7 icon-stack-3x color-info-600"></i>
                        <i class="fas fa-info icon-stack-1x text-white"></i>
                    </span>
                </div>
                <div class="flex-1 color-info-600">
                    <span class="h5 color-info-600">
                        <?= __('Metrics missing?'); ?>
                    </span>
                    <br>
                    <?= __('Have you refreshed the monitoring configuration?'); ?>
                </div>

                <?php if ($this->Acl->hasPermission('index', 'exports')): ?>
                    <a class="btn btn-outline-info btn-sm btn-w-m waves-effect waves-themed"
                       ui-sref="ExportsIndex">
                        <i class="fa fa-retweet"></i>
                        <?= __('Go to "Refresh monitoring configuration"'); ?>
                    </a>
                <?php endif; ?>
            </div>
        </div>
    </div>
</div>


<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Prometheus metrics'); ?>
                    <span class="fw-300"><i><?php echo __('of Host'); ?></i></span>
                </h2>
                <div class="panel-toolbar">

                    <ul class="nav nav-tabs border-bottom-0 nav-tabs-clean" role="tablist">
                        <?php if ($this->Acl->hasPermission('index', 'PrometheusQuery', 'PrometheusModule')): ?>
                            <li class="nav-item">
                                <a class="nav-link active" data-toggle="tab"
                                   ui-sref="PrometheusQueryIndex({hostId: hostId})" role="tab">
                                    <i class="fas fa-chart-line">&nbsp;</i> <?php echo __('Metrics'); ?>
                                </a>
                            </li>
                        <?php endif; ?>
                        <?php if ($this->Acl->hasPermission('index', 'PrometheusAlertRules', 'PrometheusModule')): ?>
                            <li class="nav-item">
                                <a class="nav-link" data-toggle="tab"
                                   ui-sref="PrometheusAlertRulesIndex({hostId: hostId})" role="tab">
                                    <i class="fas fa-bullhorn">&nbsp;</i> <?php echo __('Alert rules'); ?>
                                </a>
                            </li>
                        <?php endif; ?>
                    </ul>

                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                        <i class="fas fa-sync"></i> <?php echo __('Refresh'); ?>
                    </button>

                    <button class="btn btn-xs btn-primary shadow-0" ng-click="triggerFilter()">
                        <i class="fas fa-filter"></i> <?php echo __('Filter'); ?>
                    </button>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">

                    <!-- Start Filter -->
                    <div class="list-filter card margin-bottom-10" ng-show="showFilter">
                        <div class="card-header">
                            <i class="fa fa-filter"></i> <?php echo __('Filter'); ?>
                        </div>
                        <div class="card-body">
                            <div class="row">
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fa fa-filter"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by metric name'); ?>"
                                                   ng-model="filter.PrometheusQuery.metric"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="float-right">
                                <button type="button" ng-click="resetFilter()"
                                        class="btn btn-xs btn-danger">
                                    <?php echo __('Reset Filter'); ?>
                                </button>
                            </div>
                        </div>
                    </div>
                    <!-- End Filter -->

                    <div class="frame-wrap">
                        <table class="table table-striped m-0 table-bordered table-hover table-sm">
                            <thead>
                            <tr>
                                <th class="no-sort text-center">
                                    <i class="fa fa-check-square"></i>
                                </th>

                                <th class="no-sort text-center">
                                    <i class="fa fa-lg fa-area-chart" title="<?php echo __('Grapher'); ?>"></i>
                                </th>

                                <th class="no-sort">
                                    <?php echo __('Metric'); ?>
                                </th>

                                <th class="no-sort">
                                    <?php echo __('Help'); ?>
                                </th>

                                <th class="no-sort">
                                    <?php echo __('Type'); ?>
                                </th>

                                <th class="no-sort">
                                    <?php echo __('Unit'); ?>
                                </th>

                                <th class="no-sort text-center editItemWidth">
                                    <div class="icon-stack">
                                        <i class="fas fa-cog opacity-100"></i>
                                        <i class="fas fa-plus opacity-100 fa-xs text-success cornered cornered-lr"></i>
                                    </div>
                                </th>
                            </tr>
                            </thead>

                            <tbody>
                            <tr ng-repeat="metric in metrics">

                                <td class="width-5">
                                    <input type="checkbox"
                                           ng-model="massChange[metric.metric]"
                                           ng-show="metric.metric">
                                </td>

                                <td class="text-center">
                                    <div ng-mouseenter="mouseenter($event, host.uuid, metric)"
                                         ng-mouseleave="mouseleave()">
                                        <i class="fa fa-lg fa-area-chart">
                                        </i>
                                    </div>
                                </td>

                                <td>
                                    {{ metric.metric }}
                                </td>
                                <td>
                                    {{ metric.help }}
                                </td>
                                <td>
                                    {{ metric.type }}
                                </td>
                                <td>
                                    {{ metric.unit }}
                                </td>

                                <td class="width-50">
                                    <div class="btn-group btn-group-xs" role="group">
                                        <?php if ($this->Acl->hasPermission('toService', 'PrometheusQuery', 'PrometheusModule')): ?>
                                            <a ui-sref="PrometheusQueryToService({hostId: host.id, metrics: getCurrentMetricForServiceAdd(metric)})"
                                               class="btn btn-default btn-lower-padding">
                                                <div class="icon-stack">
                                                    <i class="fas fa-cog opacity-100"></i>
                                                    <i class="fas fa-plus opacity-100 fa-xs text-success cornered cornered-lr"></i>
                                                </div>
                                            </a>
                                        <?php else: ?>
                                            <a href="javascript:void(0);"
                                               class="btn btn-default btn-lower-padding disabled">
                                                <div class="icon-stack">
                                                    <i class="fas fa-cog opacity-100"></i>
                                                    <i class="fas fa-plus opacity-100 fa-xs text-success cornered cornered-lr"></i>
                                                </div>
                                            </a>
                                        <?php endif; ?>
                                        <button type="button"
                                                class="btn btn-default dropdown-toggle btn-lower-padding"
                                                data-toggle="dropdown">
                                            <i class="caret"></i>
                                        </button>
                                        <div class="dropdown-menu dropdown-menu-right">
                                            <?php if ($this->Acl->hasPermission('toService', 'PrometheusQuery', 'PrometheusModule')): ?>
                                                <a ui-sref="PrometheusQueryToService({hostId: host.id, metrics: getCurrentMetricForServiceAdd(metric)})"
                                                   class="dropdown-item">
                                                    <div class="icon-stack">
                                                        <i class="fas fa-cog opacity-100"></i>
                                                        <i class="fas fa-plus opacity-100 fa-xs text-success cornered cornered-lr"></i>
                                                    </div>
                                                    <?php echo __('Create service from metric'); ?>
                                                </a>
                                            <?php endif; ?>
                                            <?php
                                            $AdditionalLinks = new \App\Lib\AdditionalLinks($this);
                                            echo $AdditionalLinks->getLinksAsHtmlList('PrometheusQuery', 'index', 'list');
                                            ?>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                            </tbody>
                        </table>
                        <div class="margin-top-10" ng-show="metrics.length == 0">
                            <div class="text-center text-danger italic">
                                <?php echo __('No entries match the selection'); ?>
                            </div>
                        </div>

                        <?php if ($this->Acl->hasPermission('toService', 'PrometheusQuery', 'PrometheusModule')): ?>
                            <div class="row margin-top-10 margin-bottom-10">
                                <div class="col-xs-12 col-md-2 text-muted text-center">
                                    <span ng-show="selectedElements > 0">({{selectedElements}})</span>
                                </div>
                                <div class="col-xs-12 col-md-2">
                                    <span ng-click="selectAll()" class="pointer">
                                        <i class="fas fa-lg fa-check-square"></i>
                                        <?php echo __('Select all'); ?>
                                    </span>
                                </div>
                                <div class="col-xs-12 col-md-2">
                                    <span ng-click="undoSelection()" class="pointer">
                                        <i class="fas fa-lg fa-square"></i>
                                        <?php echo __('Undo selection'); ?>
                                    </span>
                                </div>
                                <div class="col-xs-12 col-md-2">
                                    <a ui-sref="PrometheusQueryToService({hostId: host.id, metrics: metricsForServiceAdd()})"
                                       href="javascript:void(0);" class="a-clean">
                                        <div class="icon-stack">
                                            <i class="fas fa-cog opacity-100"></i>
                                            <i class="fas fa-plus opacity-100 fa-xs text-success cornered cornered-lr"></i>
                                        </div>
                                        <?php echo __('Create service from metrics'); ?>
                                    </a>
                                </div>
                            </div>
                        <?php endif; ?>

                        <popover-prometheus-graph-directive></popover-prometheus-graph-directive>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
