angular.module('openITCOCKPIT').directive('prometheusCfgsPrometheus', function($http, $state, $rootScope, NotyService, RedirectService){
    return {
        restrict: 'E',
        templateUrl: '/prometheus_module/ConfigurationFiles/PrometheusCfgsPrometheus.html',
        scope: {},

        controller: function($scope){
            $scope.post = {};
            $rootScope.configFileModuleUrlPath = 'prometheus_module';

            $scope.init = true;
            $scope.load = function(){
                $http.get('/prometheus_module/ConfigurationFiles/PrometheusCfgsPrometheus.json', {
                    params: {
                        'angular': true
                    }
                }).then(function(result){
                    $scope.post = result.data.config;
                    $scope.init = false;
                }, function errorCallback(result){
                    if(result.status === 403){
                        $state.go('403');
                    }

                    if(result.status === 404){
                        $state.go('404');
                    }
                });
            };

            $scope.submit = function(){
                $http.post('/prometheus_module/ConfigurationFiles/PrometheusCfgsPrometheus.json?angular=true',
                    $scope.post
                ).then(function(result){
                    console.log('Data saved successfully');
                    NotyService.genericSuccess();
                    RedirectService.redirectWithFallback('ConfigurationFilesIndex');
                }, function errorCallback(result){
                    NotyService.genericError();
                    if(result.data.hasOwnProperty('error')){
                        $scope.errors = result.data.error;
                    }
                });
            };

            $scope.load();

        }
    };
});