angular.module('openITCOCKPIT').directive('prometheusServiceBrowser', function($http, NotyService){
    return {
        restrict: 'E',
        templateUrl: '/prometheus_module/PrometheusQuery/browser_directive.html',
        scope: {
            'serviceId': '=',
            'lastLoad': '='
        },

        controller: function($scope){
            $scope.init = false;
            $scope.metricDetails = [];
            $scope.showAll = false;
            $scope.displayLimit = 4;

            $scope.load = function(){
                $http.get("/prometheus_module/PrometheusQuery/browser_directive/" + $scope.serviceId + ".json", {
                    params: {
                        'angular': true
                    }
                }).then(function(result){
                    $scope.metricValue = result.data.metricValue;
                    $scope.alertRule = result.data.alertRule;
                    $scope.metricDetails = [];

                    for(var index in result.data.metricValue.data.result){
                        $scope.metricDetails.push({
                            key: result.data.metricValue.data.result[index].metric.__name__,
                            details: result.data.metricValue.data.result[index].metric,
                            value: result.data.metricValue.data.result[index].value[1]
                        });
                    }

                }, function errorCallback(result){
                    if(result.status === 403){
                        $state.go('403');
                    }

                    if(result.status === 404){
                        $state.go('404');
                    }
                });
            };

            $scope.toggleShowAll = function(){
                $scope.showAll = !$scope.showAll;
            };

            $scope.$watch('serviceId', function(){
                if($scope.serviceId != null && $scope.serviceId != ""){
                    $scope.load();
                    $scope.init = true;
                }
            }, true);

            $scope.$watch('lastLoad', function(){
                if($scope.serviceId != null && $scope.serviceId != "" && $scope.init){
                    $scope.load();
                }
            }, true);
        },

        link: function($scope, element, attr){

        }
    };
});